Docs
Cloudflare
CodeRabbit
Railway
SerpAPI
OpenRouter
WorkOS
Netlify
AG Grid
Clerk
Unkey
Electric
Prisma
Sentry
Cloudflare
CodeRabbit
Railway
SerpAPI
OpenRouter
WorkOS
Netlify
AG Grid
Clerk
Unkey
Electric
Prisma
Sentry
Table API Reference
Column API Reference
Row API Reference
Cell API Reference
Header API Reference
Features API Reference
Static Functions API Reference

Solid Example: Column Resizing

import {
  columnResizingFeature,
  columnSizingFeature,
  createColumnHelper,
  createTable,
  tableFeatures,
} from '@tanstack/solid-table'
import { For, createSignal } from 'solid-js'
import { makeData } from './makeData'
import type {
  ColumnResizeDirection,
  ColumnResizeMode,
} from '@tanstack/solid-table'
import type { Person } from './makeData'

const features = tableFeatures({ columnResizingFeature, columnSizingFeature })

const columnHelper = createColumnHelper<typeof features, Person>()

const columns = columnHelper.columns([
  columnHelper.group({
    header: 'Name',
    footer: (props) => props.column.id,
    columns: columnHelper.columns([
      columnHelper.accessor('firstName', {
        cell: (info) => info.getValue(),
        footer: (props) => props.column.id,
      }),
      columnHelper.accessor((row) => row.lastName, {
        id: 'lastName',
        cell: (info) => info.getValue(),
        header: () => <span>Last Name</span>,
        footer: (props) => props.column.id,
      }),
    ]),
  }),
  columnHelper.group({
    header: 'Info',
    footer: (props) => props.column.id,
    columns: columnHelper.columns([
      columnHelper.accessor('age', {
        header: () => 'Age',
        footer: (props) => props.column.id,
      }),
      columnHelper.group({
        header: 'More Info',
        columns: columnHelper.columns([
          columnHelper.accessor('visits', {
            header: () => <span>Visits</span>,
            footer: (props) => props.column.id,
          }),
          columnHelper.accessor('status', {
            header: 'Status',
            footer: (props) => props.column.id,
          }),
          columnHelper.accessor('progress', {
            header: 'Profile Progress',
            footer: (props) => props.column.id,
          }),
        ]),
      }),
    ]),
  }),
])

function App() {
  const [data, setData] = createSignal(makeData(10))
  const refreshData = () => setData(makeData(10))
  const stressTest = () => setData(makeData(100))
  const [columnResizeMode, setColumnResizeMode] =
    createSignal<ColumnResizeMode>('onChange')
  const [columnResizeDirection, setColumnResizeDirection] =
    createSignal<ColumnResizeDirection>('ltr')

  const table = createTable(
    {
      features,
      rowModels: {},
      columns,
      get data() {
        return data()
      },
      get columnResizeMode() {
        return columnResizeMode()
      },
      get columnResizeDirection() {
        return columnResizeDirection()
      },
      debugTable: true,
      debugHeaders: true,
      debugColumns: true,
    },
    (state) => state,
  )

  const resizerTransform = (
    header: ReturnType<typeof table.getHeaderGroups>[number]['headers'][number],
  ) => {
    if (columnResizeMode() === 'onEnd' && header.column.getIsResizing()) {
      const delta = table.atoms.columnResizing.get().deltaOffset ?? 0
      const dir = table.options.columnResizeDirection === 'rtl' ? -1 : 1
      return `translateX(${dir * delta}px)`
    }
    return ''
  }

  return (
    <div class="demo-root">
      <div>
        <button onClick={() => refreshData()}>Regenerate Data</button>
        <button onClick={() => stressTest()}>Stress Test (100 rows)</button>
      </div>
      <select
        value={columnResizeMode()}
        onChange={(e) =>
          setColumnResizeMode(e.currentTarget.value as ColumnResizeMode)
        }
        class="demo-button outlined-control"
      >
        <option value="onEnd">Resize: "onEnd"</option>
        <option value="onChange">Resize: "onChange"</option>
      </select>
      <select
        value={columnResizeDirection()}
        onChange={(e) =>
          setColumnResizeDirection(
            e.currentTarget.value as ColumnResizeDirection,
          )
        }
        class="demo-button outlined-control"
      >
        <option value="ltr">Resize Direction: "ltr"</option>
        <option value="rtl">Resize Direction: "rtl"</option>
      </select>
      <div style={{ direction: table.options.columnResizeDirection }}>
        <div class="spacer-md" />
        <div class="section-title">{'<table/>'}</div>
        <div class="scroll-container">
          <table style={{ width: `${table.getCenterTotalSize()}px` }}>
            <thead>
              <For each={table.getHeaderGroups()}>
                {(headerGroup) => (
                  <tr>
                    <For each={headerGroup.headers}>
                      {(header) => (
                        <th
                          colSpan={header.colSpan}
                          style={{ width: `${header.getSize()}px` }}
                        >
                          {header.isPlaceholder ? null : (
                            <table.FlexRender header={header} />
                          )}
                          <div
                            onDblClick={() => header.column.resetSize()}
                            onMouseDown={header.getResizeHandler()}
                            onTouchStart={header.getResizeHandler()}
                            class={`resizer ${table.options.columnResizeDirection} ${header.column.getIsResizing() ? 'isResizing' : ''}`}
                            style={{ transform: resizerTransform(header) }}
                          />
                        </th>
                      )}
                    </For>
                  </tr>
                )}
              </For>
            </thead>
            <tbody>
              <For each={table.getRowModel().rows}>
                {(row) => (
                  <tr>
                    <For each={row.getAllCells()}>
                      {(cell) => (
                        <td style={{ width: `${cell.column.getSize()}px` }}>
                          <table.FlexRender cell={cell} />
                        </td>
                      )}
                    </For>
                  </tr>
                )}
              </For>
            </tbody>
          </table>
        </div>
        <div class="spacer-md" />
        <div class="section-title">{'<div/> (relative)'}</div>
        <div class="scroll-container">
          <div class="divTable" style={{ width: `${table.getTotalSize()}px` }}>
            <div class="thead">
              <For each={table.getHeaderGroups()}>
                {(headerGroup) => (
                  <div class="tr">
                    <For each={headerGroup.headers}>
                      {(header) => (
                        <div
                          class="th"
                          style={{ width: `${header.getSize()}px` }}
                        >
                          {header.isPlaceholder ? null : (
                            <table.FlexRender header={header} />
                          )}
                          <div
                            onDblClick={() => header.column.resetSize()}
                            onMouseDown={header.getResizeHandler()}
                            onTouchStart={header.getResizeHandler()}
                            class={`resizer ${table.options.columnResizeDirection} ${header.column.getIsResizing() ? 'isResizing' : ''}`}
                            style={{ transform: resizerTransform(header) }}
                          />
                        </div>
                      )}
                    </For>
                  </div>
                )}
              </For>
            </div>
            <div class="tbody">
              <For each={table.getRowModel().rows}>
                {(row) => (
                  <div class="tr">
                    <For each={row.getAllCells()}>
                      {(cell) => (
                        <div
                          class="td"
                          style={{ width: `${cell.column.getSize()}px` }}
                        >
                          <table.FlexRender cell={cell} />
                        </div>
                      )}
                    </For>
                  </div>
                )}
              </For>
            </div>
          </div>
        </div>
        <div class="spacer-md" />
        <div class="section-title">{'<div/> (absolute positioning)'}</div>
        <div class="scroll-container">
          <div class="divTable" style={{ width: `${table.getTotalSize()}px` }}>
            <div class="thead">
              <For each={table.getHeaderGroups()}>
                {(headerGroup) => (
                  <div class="tr" style={{ position: 'relative' }}>
                    <For each={headerGroup.headers}>
                      {(header) => (
                        <div
                          class="th"
                          style={{
                            position: 'absolute',
                            left: `${header.getStart()}px`,
                            width: `${header.getSize()}px`,
                          }}
                        >
                          {header.isPlaceholder ? null : (
                            <table.FlexRender header={header} />
                          )}
                          <div
                            onDblClick={() => header.column.resetSize()}
                            onMouseDown={header.getResizeHandler()}
                            onTouchStart={header.getResizeHandler()}
                            class={`resizer ${table.options.columnResizeDirection} ${header.column.getIsResizing() ? 'isResizing' : ''}`}
                            style={{ transform: resizerTransform(header) }}
                          />
                        </div>
                      )}
                    </For>
                  </div>
                )}
              </For>
            </div>
            <div class="tbody">
              <For each={table.getRowModel().rows}>
                {(row) => (
                  <div class="tr" style={{ position: 'relative' }}>
                    <For each={row.getAllCells()}>
                      {(cell) => (
                        <div
                          class="td"
                          style={{
                            position: 'absolute',
                            left: `${cell.column.getStart()}px`,
                            width: `${cell.column.getSize()}px`,
                          }}
                        >
                          <table.FlexRender cell={cell} />
                        </div>
                      )}
                    </For>
                  </div>
                )}
              </For>
            </div>
          </div>
        </div>
      </div>
      <div class="spacer-md" />
      <pre>{JSON.stringify(table.store.get(), null, 2)}</pre>
    </div>
  )
}

export default App
import {
  columnResizingFeature,
  columnSizingFeature,
  createColumnHelper,
  createTable,
  tableFeatures,
} from '@tanstack/solid-table'
import { For, createSignal } from 'solid-js'
import { makeData } from './makeData'
import type {
  ColumnResizeDirection,
  ColumnResizeMode,
} from '@tanstack/solid-table'
import type { Person } from './makeData'

const features = tableFeatures({ columnResizingFeature, columnSizingFeature })

const columnHelper = createColumnHelper<typeof features, Person>()

const columns = columnHelper.columns([
  columnHelper.group({
    header: 'Name',
    footer: (props) => props.column.id,
    columns: columnHelper.columns([
      columnHelper.accessor('firstName', {
        cell: (info) => info.getValue(),
        footer: (props) => props.column.id,
      }),
      columnHelper.accessor((row) => row.lastName, {
        id: 'lastName',
        cell: (info) => info.getValue(),
        header: () => <span>Last Name</span>,
        footer: (props) => props.column.id,
      }),
    ]),
  }),
  columnHelper.group({
    header: 'Info',
    footer: (props) => props.column.id,
    columns: columnHelper.columns([
      columnHelper.accessor('age', {
        header: () => 'Age',
        footer: (props) => props.column.id,
      }),
      columnHelper.group({
        header: 'More Info',
        columns: columnHelper.columns([
          columnHelper.accessor('visits', {
            header: () => <span>Visits</span>,
            footer: (props) => props.column.id,
          }),
          columnHelper.accessor('status', {
            header: 'Status',
            footer: (props) => props.column.id,
          }),
          columnHelper.accessor('progress', {
            header: 'Profile Progress',
            footer: (props) => props.column.id,
          }),
        ]),
      }),
    ]),
  }),
])

function App() {
  const [data, setData] = createSignal(makeData(10))
  const refreshData = () => setData(makeData(10))
  const stressTest = () => setData(makeData(100))
  const [columnResizeMode, setColumnResizeMode] =
    createSignal<ColumnResizeMode>('onChange')
  const [columnResizeDirection, setColumnResizeDirection] =
    createSignal<ColumnResizeDirection>('ltr')

  const table = createTable(
    {
      features,
      rowModels: {},
      columns,
      get data() {
        return data()
      },
      get columnResizeMode() {
        return columnResizeMode()
      },
      get columnResizeDirection() {
        return columnResizeDirection()
      },
      debugTable: true,
      debugHeaders: true,
      debugColumns: true,
    },
    (state) => state,
  )

  const resizerTransform = (
    header: ReturnType<typeof table.getHeaderGroups>[number]['headers'][number],
  ) => {
    if (columnResizeMode() === 'onEnd' && header.column.getIsResizing()) {
      const delta = table.atoms.columnResizing.get().deltaOffset ?? 0
      const dir = table.options.columnResizeDirection === 'rtl' ? -1 : 1
      return `translateX(${dir * delta}px)`
    }
    return ''
  }

  return (
    <div class="demo-root">
      <div>
        <button onClick={() => refreshData()}>Regenerate Data</button>
        <button onClick={() => stressTest()}>Stress Test (100 rows)</button>
      </div>
      <select
        value={columnResizeMode()}
        onChange={(e) =>
          setColumnResizeMode(e.currentTarget.value as ColumnResizeMode)
        }
        class="demo-button outlined-control"
      >
        <option value="onEnd">Resize: "onEnd"</option>
        <option value="onChange">Resize: "onChange"</option>
      </select>
      <select
        value={columnResizeDirection()}
        onChange={(e) =>
          setColumnResizeDirection(
            e.currentTarget.value as ColumnResizeDirection,
          )
        }
        class="demo-button outlined-control"
      >
        <option value="ltr">Resize Direction: "ltr"</option>
        <option value="rtl">Resize Direction: "rtl"</option>
      </select>
      <div style={{ direction: table.options.columnResizeDirection }}>
        <div class="spacer-md" />
        <div class="section-title">{'<table/>'}</div>
        <div class="scroll-container">
          <table style={{ width: `${table.getCenterTotalSize()}px` }}>
            <thead>
              <For each={table.getHeaderGroups()}>
                {(headerGroup) => (
                  <tr>
                    <For each={headerGroup.headers}>
                      {(header) => (
                        <th
                          colSpan={header.colSpan}
                          style={{ width: `${header.getSize()}px` }}
                        >
                          {header.isPlaceholder ? null : (
                            <table.FlexRender header={header} />
                          )}
                          <div
                            onDblClick={() => header.column.resetSize()}
                            onMouseDown={header.getResizeHandler()}
                            onTouchStart={header.getResizeHandler()}
                            class={`resizer ${table.options.columnResizeDirection} ${header.column.getIsResizing() ? 'isResizing' : ''}`}
                            style={{ transform: resizerTransform(header) }}
                          />
                        </th>
                      )}
                    </For>
                  </tr>
                )}
              </For>
            </thead>
            <tbody>
              <For each={table.getRowModel().rows}>
                {(row) => (
                  <tr>
                    <For each={row.getAllCells()}>
                      {(cell) => (
                        <td style={{ width: `${cell.column.getSize()}px` }}>
                          <table.FlexRender cell={cell} />
                        </td>
                      )}
                    </For>
                  </tr>
                )}
              </For>
            </tbody>
          </table>
        </div>
        <div class="spacer-md" />
        <div class="section-title">{'<div/> (relative)'}</div>
        <div class="scroll-container">
          <div class="divTable" style={{ width: `${table.getTotalSize()}px` }}>
            <div class="thead">
              <For each={table.getHeaderGroups()}>
                {(headerGroup) => (
                  <div class="tr">
                    <For each={headerGroup.headers}>
                      {(header) => (
                        <div
                          class="th"
                          style={{ width: `${header.getSize()}px` }}
                        >
                          {header.isPlaceholder ? null : (
                            <table.FlexRender header={header} />
                          )}
                          <div
                            onDblClick={() => header.column.resetSize()}
                            onMouseDown={header.getResizeHandler()}
                            onTouchStart={header.getResizeHandler()}
                            class={`resizer ${table.options.columnResizeDirection} ${header.column.getIsResizing() ? 'isResizing' : ''}`}
                            style={{ transform: resizerTransform(header) }}
                          />
                        </div>
                      )}
                    </For>
                  </div>
                )}
              </For>
            </div>
            <div class="tbody">
              <For each={table.getRowModel().rows}>
                {(row) => (
                  <div class="tr">
                    <For each={row.getAllCells()}>
                      {(cell) => (
                        <div
                          class="td"
                          style={{ width: `${cell.column.getSize()}px` }}
                        >
                          <table.FlexRender cell={cell} />
                        </div>
                      )}
                    </For>
                  </div>
                )}
              </For>
            </div>
          </div>
        </div>
        <div class="spacer-md" />
        <div class="section-title">{'<div/> (absolute positioning)'}</div>
        <div class="scroll-container">
          <div class="divTable" style={{ width: `${table.getTotalSize()}px` }}>
            <div class="thead">
              <For each={table.getHeaderGroups()}>
                {(headerGroup) => (
                  <div class="tr" style={{ position: 'relative' }}>
                    <For each={headerGroup.headers}>
                      {(header) => (
                        <div
                          class="th"
                          style={{
                            position: 'absolute',
                            left: `${header.getStart()}px`,
                            width: `${header.getSize()}px`,
                          }}
                        >
                          {header.isPlaceholder ? null : (
                            <table.FlexRender header={header} />
                          )}
                          <div
                            onDblClick={() => header.column.resetSize()}
                            onMouseDown={header.getResizeHandler()}
                            onTouchStart={header.getResizeHandler()}
                            class={`resizer ${table.options.columnResizeDirection} ${header.column.getIsResizing() ? 'isResizing' : ''}`}
                            style={{ transform: resizerTransform(header) }}
                          />
                        </div>
                      )}
                    </For>
                  </div>
                )}
              </For>
            </div>
            <div class="tbody">
              <For each={table.getRowModel().rows}>
                {(row) => (
                  <div class="tr" style={{ position: 'relative' }}>
                    <For each={row.getAllCells()}>
                      {(cell) => (
                        <div
                          class="td"
                          style={{
                            position: 'absolute',
                            left: `${cell.column.getStart()}px`,
                            width: `${cell.column.getSize()}px`,
                          }}
                        >
                          <table.FlexRender cell={cell} />
                        </div>
                      )}
                    </For>
                  </div>
                )}
              </For>
            </div>
          </div>
        </div>
      </div>
      <div class="spacer-md" />
      <pre>{JSON.stringify(table.store.get(), null, 2)}</pre>
    </div>
  )
}

export default App

Docs
Cloudflare
Railway
CodeRabbit
OpenRouter
WorkOS
Netlify
Clerk
SerpAPI
AG Grid
Prisma
Unkey
Electric
Sentry
Cloudflare
Railway
CodeRabbit
OpenRouter
WorkOS
Netlify
Clerk
SerpAPI
AG Grid
Prisma
Unkey
Electric
Sentry
Table API Reference
Column API Reference
Row API Reference
Cell API Reference
Header API Reference
Features API Reference
Static Functions API Reference

Svelte Example: Column Resizing

<script lang="ts">
  import {
    columnResizingFeature,
    columnSizingFeature,
    createColumnHelper,
    createTable,
    FlexRender,
    tableFeatures,
  } from '@tanstack/svelte-table'
  import type {
    ColumnResizeDirection,
    ColumnResizeMode,
  } from '@tanstack/svelte-table'
  import { makeData, type Person } from './makeData'
  import './index.css'

  const features = tableFeatures({
    columnResizingFeature,
    columnSizingFeature,
  })

  const columnHelper = createColumnHelper<typeof features, Person>()

  const columns = columnHelper.columns([
    columnHelper.group({
      header: 'Name',
      footer: (props) => props.column.id,
      columns: columnHelper.columns([
        columnHelper.accessor('firstName', {
          cell: (info) => info.getValue(),
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor((row) => row.lastName, {
          id: 'lastName',
          cell: (info) => info.getValue(),
          header: () => 'Last Name',
          footer: (props) => props.column.id,
        }),
      ]),
    }),
    columnHelper.group({
      header: 'Info',
      footer: (props) => props.column.id,
      columns: columnHelper.columns([
        columnHelper.accessor('age', {
          header: () => 'Age',
          footer: (props) => props.column.id,
        }),
        columnHelper.group({
          header: 'More Info',
          columns: columnHelper.columns([
            columnHelper.accessor('visits', {
              header: () => 'Visits',
              footer: (props) => props.column.id,
            }),
            columnHelper.accessor('status', {
              header: 'Status',
              footer: (props) => props.column.id,
            }),
            columnHelper.accessor('progress', {
              header: 'Profile Progress',
              footer: (props) => props.column.id,
            }),
          ]),
        }),
      ]),
    }),
  ])

  let data = $state(makeData(10))
  const refreshData = () => { data = makeData(10) }
  const stressTest = () => { data = makeData(100) }

  let columnResizeMode = $state<ColumnResizeMode>('onChange')
  let columnResizeDirection = $state<ColumnResizeDirection>('ltr')

  const table = createTable(
    {
      features,
      rowModels: {},
      columns,
      get data() {
        return data
      },
      get columnResizeMode() {
        return columnResizeMode
      },
      get columnResizeDirection() {
        return columnResizeDirection
      },
      debugTable: true,
      debugHeaders: true,
      debugColumns: true,
    },
    (state) => state,
  )

  function resizerTransform(
    header: ReturnType<typeof table.getHeaderGroups>[number]['headers'][number],
  ) {
    if (columnResizeMode === 'onEnd' && header.column.getIsResizing()) {
      const delta = table.state.columnResizing.deltaOffset ?? 0
      const dir = table.options.columnResizeDirection === 'rtl' ? -1 : 1
      return `translateX(${dir * delta
      }px)`
    }
    return ''
  }
</script>

<div class="demo-root">
  <div>
    <button onclick={() => refreshData()}>Regenerate Data</button>
    <button onclick={() => stressTest()}>Stress Test (100 rows)</button>
  </div>
  <select
    value={columnResizeMode}
    onchange={(e) => {
      columnResizeMode = (e.target as HTMLSelectElement).value as ColumnResizeMode
    }}
    class="demo-button outlined-control"
  >
    <option value="onEnd">Resize: "onEnd"</option>
    <option value="onChange">Resize: "onChange"</option>
  </select>
  <select
    value={columnResizeDirection}
    onchange={(e) => {
      columnResizeDirection = (e.target as HTMLSelectElement)
        .value as ColumnResizeDirection
    }}
    class="demo-button outlined-control"
  >
    <option value="ltr">Resize Direction: "ltr"</option>
    <option value="rtl">Resize Direction: "rtl"</option>
  </select>
  <div style:direction={table.options.columnResizeDirection}>
    <div class="spacer-md"></div>
    <div class="section-title">{'<table/>'}</div>
    <div class="scroll-container">
      <table style="width: {table.getCenterTotalSize()
      }px">
        <thead>
          {#each table.getHeaderGroups() as headerGroup (headerGroup.id)}
            <tr>
              {#each headerGroup.headers as header (header.id)}
                <th
                  colSpan={header.colSpan}
                  style="width: {header.getSize()}px"
                >
                  {#if !header.isPlaceholder}
                    <FlexRender header={header} />
                  {/if}
                  <div
                    ondblclick={() => header.column.resetSize()}
                    onmousedown={header.getResizeHandler()}
                    ontouchstart={header.getResizeHandler()}
                    aria-hidden="true"
                    class="resizer {table.options
                      .columnResizeDirection} {header.column.getIsResizing()
                      ? 'isResizing'
                      : ''}"
                    style="transform: {resizerTransform(header)}"
                  ></div>
                </th>
              {/each}
            </tr>
          {/each}
        </thead>
        <tbody>
          {#each table.getRowModel().rows as row (row.id)}
            <tr>
              {#each row.getAllCells() as cell (cell.id)}
                <td style="width: {cell.column.getSize()}px">
                  <FlexRender cell={cell} />
                </td>
              {/each}
            </tr>
          {/each}
        </tbody>
      </table>
    </div>
    <div class="spacer-md"></div>
    <div class="section-title">{'<div/> (relative)'
    }</div>
    <div class="scroll-container">
      <div class="divTable" style="width: {table.getTotalSize()}px">
        <div class="thead">
          {#each table.getHeaderGroups() as headerGroup (headerGroup.id)}
            <div class="tr">
              {#each headerGroup.headers as header (header.id)}
                <div class="th" style="width: {header.getSize()}px">
                  {#if !header.isPlaceholder}
                    <FlexRender header={header} />
                  {/if}
                  <div
                    ondblclick={() => header.column.resetSize()}
                    onmousedown={header.getResizeHandler()}
                    ontouchstart={header.getResizeHandler()}
                    aria-hidden="true"
                    class="resizer {table.options
                      .columnResizeDirection} {header.column.getIsResizing()
                      ? 'isResizing'
                      : ''}"
                    style="transform: {resizerTransform(header)}"
                  ></div>
                </div>
              {/each}
            </div>
          {/each}
        </div>
        <div class="tbody">
          {#each table.getRowModel().rows as row (row.id)}
            <div class="tr">
              {#each row.getAllCells() as cell (cell.id)}
                <div class="td" style="width: {cell.column.getSize()}px">
                  <FlexRender cell={cell} />
                </div>
              {/each}
            </div>
          {/each}
        </div>
      </div>
    </div>
    <div class="spacer-md"></div>
    <div class="section-title">{'<div/> (absolute positioning)'}</div>
    <div class="scroll-container">
      <div class="divTable" style="width: {table.getTotalSize()}px">
        <div class="thead">
          {#each table.getHeaderGroups() as headerGroup (headerGroup.id)}
            <div class="tr" style="position: relative">
              {#each headerGroup.headers as header (header.id)}
                <div
                  class="th"
                  style="position: absolute; left: {header.getStart()}px; width: {header.getSize()}px"
                >
                  {#if !header.isPlaceholder}
                    <FlexRender header={header} />
                  {/if}
                  <div
                    ondblclick={() => header.column.resetSize()}
                    onmousedown={header.getResizeHandler()}
                    ontouchstart={header.getResizeHandler()}
                    aria-hidden="true"
                    class="resizer {table.options
                      .columnResizeDirection} {header.column.getIsResizing()
                      ? 'isResizing'
                      : ''}"
                    style="transform: {resizerTransform(header)}"
                  ></div>
                </div>
              {/each}
            </div>
          {/each}
        </div>
        <div class="tbody">
          {#each table.getRowModel().rows as row (row.id)}
            <div class="tr" style="position: relative">
              {#each row.getAllCells() as cell (cell.id)}
                <div
                  class="td"
                  style="position: absolute; left: {cell.column.getStart()}px; width: {cell.column.getSize()}px"
                >
                  <FlexRender cell={cell} />
                </div>
              {/each}
            </div>
          {/each}
        </div>
      </div>
    </div>
  </div>
  <div class="spacer-md"></div>
  <pre>{JSON.stringify(table.state, null, 2)}</pre>
</div>
<script lang="ts">
  import {
    columnResizingFeature,
    columnSizingFeature,
    createColumnHelper,
    createTable,
    FlexRender,
    tableFeatures,
  } from '@tanstack/svelte-table'
  import type {
    ColumnResizeDirection,
    ColumnResizeMode,
  } from '@tanstack/svelte-table'
  import { makeData, type Person } from './makeData'
  import './index.css'

  const features = tableFeatures({
    columnResizingFeature,
    columnSizingFeature,
  })

  const columnHelper = createColumnHelper<typeof features, Person>()

  const columns = columnHelper.columns([
    columnHelper.group({
      header: 'Name',
      footer: (props) => props.column.id,
      columns: columnHelper.columns([
        columnHelper.accessor('firstName', {
          cell: (info) => info.getValue(),
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor((row) => row.lastName, {
          id: 'lastName',
          cell: (info) => info.getValue(),
          header: () => 'Last Name',
          footer: (props) => props.column.id,
        }),
      ]),
    }),
    columnHelper.group({
      header: 'Info',
      footer: (props) => props.column.id,
      columns: columnHelper.columns([
        columnHelper.accessor('age', {
          header: () => 'Age',
          footer: (props) => props.column.id,
        }),
        columnHelper.group({
          header: 'More Info',
          columns: columnHelper.columns([
            columnHelper.accessor('visits', {
              header: () => 'Visits',
              footer: (props) => props.column.id,
            }),
            columnHelper.accessor('status', {
              header: 'Status',
              footer: (props) => props.column.id,
            }),
            columnHelper.accessor('progress', {
              header: 'Profile Progress',
              footer: (props) => props.column.id,
            }),
          ]),
        }),
      ]),
    }),
  ])

  let data = $state(makeData(10))
  const refreshData = () => { data = makeData(10) }
  const stressTest = () => { data = makeData(100) }

  let columnResizeMode = $state<ColumnResizeMode>('onChange')
  let columnResizeDirection = $state<ColumnResizeDirection>('ltr')

  const table = createTable(
    {
      features,
      rowModels: {},
      columns,
      get data() {
        return data
      },
      get columnResizeMode() {
        return columnResizeMode
      },
      get columnResizeDirection() {
        return columnResizeDirection
      },
      debugTable: true,
      debugHeaders: true,
      debugColumns: true,
    },
    (state) => state,
  )

  function resizerTransform(
    header: ReturnType<typeof table.getHeaderGroups>[number]['headers'][number],
  ) {
    if (columnResizeMode === 'onEnd' && header.column.getIsResizing()) {
      const delta = table.state.columnResizing.deltaOffset ?? 0
      const dir = table.options.columnResizeDirection === 'rtl' ? -1 : 1
      return `translateX(${dir * delta
      }px)`
    }
    return ''
  }
</script>

<div class="demo-root">
  <div>
    <button onclick={() => refreshData()}>Regenerate Data</button>
    <button onclick={() => stressTest()}>Stress Test (100 rows)</button>
  </div>
  <select
    value={columnResizeMode}
    onchange={(e) => {
      columnResizeMode = (e.target as HTMLSelectElement).value as ColumnResizeMode
    }}
    class="demo-button outlined-control"
  >
    <option value="onEnd">Resize: "onEnd"</option>
    <option value="onChange">Resize: "onChange"</option>
  </select>
  <select
    value={columnResizeDirection}
    onchange={(e) => {
      columnResizeDirection = (e.target as HTMLSelectElement)
        .value as ColumnResizeDirection
    }}
    class="demo-button outlined-control"
  >
    <option value="ltr">Resize Direction: "ltr"</option>
    <option value="rtl">Resize Direction: "rtl"</option>
  </select>
  <div style:direction={table.options.columnResizeDirection}>
    <div class="spacer-md"></div>
    <div class="section-title">{'<table/>'}</div>
    <div class="scroll-container">
      <table style="width: {table.getCenterTotalSize()
      }px">
        <thead>
          {#each table.getHeaderGroups() as headerGroup (headerGroup.id)}
            <tr>
              {#each headerGroup.headers as header (header.id)}
                <th
                  colSpan={header.colSpan}
                  style="width: {header.getSize()}px"
                >
                  {#if !header.isPlaceholder}
                    <FlexRender header={header} />
                  {/if}
                  <div
                    ondblclick={() => header.column.resetSize()}
                    onmousedown={header.getResizeHandler()}
                    ontouchstart={header.getResizeHandler()}
                    aria-hidden="true"
                    class="resizer {table.options
                      .columnResizeDirection} {header.column.getIsResizing()
                      ? 'isResizing'
                      : ''}"
                    style="transform: {resizerTransform(header)}"
                  ></div>
                </th>
              {/each}
            </tr>
          {/each}
        </thead>
        <tbody>
          {#each table.getRowModel().rows as row (row.id)}
            <tr>
              {#each row.getAllCells() as cell (cell.id)}
                <td style="width: {cell.column.getSize()}px">
                  <FlexRender cell={cell} />
                </td>
              {/each}
            </tr>
          {/each}
        </tbody>
      </table>
    </div>
    <div class="spacer-md"></div>
    <div class="section-title">{'<div/> (relative)'
    }</div>
    <div class="scroll-container">
      <div class="divTable" style="width: {table.getTotalSize()}px">
        <div class="thead">
          {#each table.getHeaderGroups() as headerGroup (headerGroup.id)}
            <div class="tr">
              {#each headerGroup.headers as header (header.id)}
                <div class="th" style="width: {header.getSize()}px">
                  {#if !header.isPlaceholder}
                    <FlexRender header={header} />
                  {/if}
                  <div
                    ondblclick={() => header.column.resetSize()}
                    onmousedown={header.getResizeHandler()}
                    ontouchstart={header.getResizeHandler()}
                    aria-hidden="true"
                    class="resizer {table.options
                      .columnResizeDirection} {header.column.getIsResizing()
                      ? 'isResizing'
                      : ''}"
                    style="transform: {resizerTransform(header)}"
                  ></div>
                </div>
              {/each}
            </div>
          {/each}
        </div>
        <div class="tbody">
          {#each table.getRowModel().rows as row (row.id)}
            <div class="tr">
              {#each row.getAllCells() as cell (cell.id)}
                <div class="td" style="width: {cell.column.getSize()}px">
                  <FlexRender cell={cell} />
                </div>
              {/each}
            </div>
          {/each}
        </div>
      </div>
    </div>
    <div class="spacer-md"></div>
    <div class="section-title">{'<div/> (absolute positioning)'}</div>
    <div class="scroll-container">
      <div class="divTable" style="width: {table.getTotalSize()}px">
        <div class="thead">
          {#each table.getHeaderGroups() as headerGroup (headerGroup.id)}
            <div class="tr" style="position: relative">
              {#each headerGroup.headers as header (header.id)}
                <div
                  class="th"
                  style="position: absolute; left: {header.getStart()}px; width: {header.getSize()}px"
                >
                  {#if !header.isPlaceholder}
                    <FlexRender header={header} />
                  {/if}
                  <div
                    ondblclick={() => header.column.resetSize()}
                    onmousedown={header.getResizeHandler()}
                    ontouchstart={header.getResizeHandler()}
                    aria-hidden="true"
                    class="resizer {table.options
                      .columnResizeDirection} {header.column.getIsResizing()
                      ? 'isResizing'
                      : ''}"
                    style="transform: {resizerTransform(header)}"
                  ></div>
                </div>
              {/each}
            </div>
          {/each}
        </div>
        <div class="tbody">
          {#each table.getRowModel().rows as row (row.id)}
            <div class="tr" style="position: relative">
              {#each row.getAllCells() as cell (cell.id)}
                <div
                  class="td"
                  style="position: absolute; left: {cell.column.getStart()}px; width: {cell.column.getSize()}px"
                >
                  <FlexRender cell={cell} />
                </div>
              {/each}
            </div>
          {/each}
        </div>
      </div>
    </div>
  </div>
  <div class="spacer-md"></div>
  <pre>{JSON.stringify(table.state, null, 2)}</pre>
</div>

Docs
CodeRabbit
Cloudflare
Railway
AG Grid
OpenRouter
Netlify
SerpAPI
Clerk
WorkOS
Electric
Unkey
Sentry
Prisma
CodeRabbit
Cloudflare
Railway
AG Grid
OpenRouter
Netlify
SerpAPI
Clerk
WorkOS
Electric
Unkey
Sentry
Prisma
Table API Reference
Column API Reference
Row API Reference
Cell API Reference
Header API Reference
Features API Reference
Static Functions API Reference
Legacy API Reference

React Example: Column Resizing

import React from 'react'
import ReactDOM from 'react-dom/client'
import {
  columnResizingFeature,
  columnSizingFeature,
  createColumnHelper,
  tableFeatures,
  useTable,
} from '@tanstack/react-table'
import { makeData } from './makeData'
import type {
  ColumnResizeDirection,
  ColumnResizeMode,
} from '@tanstack/react-table'
import type { Person } from './makeData'
import './index.css'

const features = tableFeatures({ columnResizingFeature, columnSizingFeature })

const columnHelper = createColumnHelper<typeof features, Person>()

const columns = columnHelper.columns([
  columnHelper.group({
    header: 'Name',
    footer: (props) => props.column.id,
    columns: columnHelper.columns([
      columnHelper.accessor('firstName', {
        cell: (info) => info.getValue(),
        footer: (props) => props.column.id,
      }),
      columnHelper.accessor((row) => row.lastName, {
        id: 'lastName',
        cell: (info) => info.getValue(),
        header: () => <span>Last Name</span>,
        footer: (props) => props.column.id,
      }),
    ]),
  }),
  columnHelper.group({
    header: 'Info',
    footer: (props) => props.column.id,
    columns: columnHelper.columns([
      columnHelper.accessor('age', {
        header: () => 'Age',
        footer: (props) => props.column.id,
      }),
      columnHelper.group({
        header: 'More Info',
        columns: columnHelper.columns([
          columnHelper.accessor('visits', {
            header: () => <span>Visits</span>,
            footer: (props) => props.column.id,
          }),
          columnHelper.accessor('status', {
            header: 'Status',
            footer: (props) => props.column.id,
          }),
          columnHelper.accessor('progress', {
            header: 'Profile Progress',
            footer: (props) => props.column.id,
          }),
        ]),
      }),
    ]),
  }),
])

function App() {
  const [data, setData] = React.useState(() => makeData(10))
  const refreshData = () => setData(makeData(10))
  const stressTest = () => setData(makeData(100))

  const [columnResizeMode, setColumnResizeMode] =
    React.useState<ColumnResizeMode>('onChange')

  const [columnResizeDirection, setColumnResizeDirection] =
    React.useState<ColumnResizeDirection>('ltr')

  const rerender = React.useReducer(() => ({}), {})[1]

  const table = useTable(
    {
      features,
      rowModels: {},
      columns,
      data,
      columnResizeMode,
      columnResizeDirection,
      debugTable: true,
      debugHeaders: true,
      debugColumns: true,
    },
    (state) => state, // default selector
  )

  return (
    <div className="demo-root">
      <div>
        <button onClick={() => refreshData()} className="demo-button">
          Regenerate Data
        </button>
        <button onClick={() => stressTest()} className="demo-button">
          Stress Test (100 rows)
        </button>
      </div>
      <div className="spacer-md" />
      <select
        value={columnResizeMode}
        onChange={(e) =>
          setColumnResizeMode(e.target.value as ColumnResizeMode)
        }
        className="demo-button outlined-control"
      >
        <option value="onEnd">Resize: "onEnd"</option>
        <option value="onChange">Resize: "onChange"</option>
      </select>
      <select
        value={columnResizeDirection}
        onChange={(e) =>
          setColumnResizeDirection(e.target.value as ColumnResizeDirection)
        }
        className="demo-button outlined-control"
      >
        <option value="ltr">Resize Direction: "ltr"</option>
        <option value="rtl">Resize Direction: "rtl"</option>
      </select>
      <div style={{ direction: table.options.columnResizeDirection }}>
        <div className="spacer-md" />
        <div className="section-title">{'<table/>'}</div>
        <div className="scroll-container">
          <table style={{ width: table.getCenterTotalSize() }}>
            <thead>
              {table.getHeaderGroups().map((headerGroup) => (
                <tr key={headerGroup.id}>
                  {headerGroup.headers.map((header) => (
                    <th
                      key={header.id}
                      colSpan={header.colSpan}
                      style={{
                        width: header.getSize(),
                      }}
                    >
                      {header.isPlaceholder ? null : (
                        <table.FlexRender header={header} />
                      )}
                      <div
                        onDoubleClick={() => header.column.resetSize()}
                        onMouseDown={header.getResizeHandler()}
                        onTouchStart={header.getResizeHandler()}
                        className={`resizer ${
                          table.options.columnResizeDirection
                        } ${header.column.getIsResizing() ? 'isResizing' : ''}`}
                        style={{
                          transform:
                            columnResizeMode === 'onEnd' &&
                            header.column.getIsResizing()
                              ? `translateX(${
                                  (table.options.columnResizeDirection === 'rtl'
                                    ? -1
                                    : 1) *
                                  (table.state.columnResizing.deltaOffset ?? 0)
                                }px)`
                              : '',
                        }}
                      />
                    </th>
                  ))}
                </tr>
              ))}
            </thead>
            <tbody>
              {table.getRowModel().rows.map((row) => (
                <tr key={row.id}>
                  {row.getAllCells().map((cell) => (
                    <td
                      key={cell.id}
                      style={{
                        width: cell.column.getSize(),
                      }}
                    >
                      <table.FlexRender cell={cell} />
                    </td>
                  ))}
                </tr>
              ))}
            </tbody>
          </table>
        </div>
        <div className="spacer-md" />
        <div className="section-title">{'<div/> (relative)'}</div>
        <div className="scroll-container">
          <div className="divTable" style={{ width: table.getTotalSize() }}>
            <div className="thead">
              {table.getHeaderGroups().map((headerGroup) => (
                <div key={headerGroup.id} className="tr">
                  {headerGroup.headers.map((header) => (
                    <div
                      key={header.id}
                      className="th"
                      style={{
                        width: header.getSize(),
                      }}
                    >
                      {header.isPlaceholder ? null : (
                        <table.FlexRender header={header} />
                      )}
                      <div
                        onDoubleClick={() => header.column.resetSize()}
                        onMouseDown={header.getResizeHandler()}
                        onTouchStart={header.getResizeHandler()}
                        className={`resizer ${
                          table.options.columnResizeDirection
                        } ${header.column.getIsResizing() ? 'isResizing' : ''}`}
                        style={{
                          transform:
                            columnResizeMode === 'onEnd' &&
                            header.column.getIsResizing()
                              ? `translateX(${
                                  (table.options.columnResizeDirection === 'rtl'
                                    ? -1
                                    : 1) *
                                  (table.state.columnResizing.deltaOffset ?? 0)
                                }px)`
                              : '',
                        }}
                      />
                    </div>
                  ))}
                </div>
              ))}
            </div>
            <div className="tbody">
              {table.getRowModel().rows.map((row) => (
                <div key={row.id} className="tr">
                  {row.getAllCells().map((cell) => (
                    <div
                      key={cell.id}
                      className="td"
                      style={{
                        width: cell.column.getSize(),
                      }}
                    >
                      <table.FlexRender cell={cell} />
                    </div>
                  ))}
                </div>
              ))}
            </div>
          </div>
        </div>
        <div className="spacer-md" />
        <div className="section-title">{'<div/> (absolute positioning)'}</div>
        <div className="scroll-container">
          <div
            className="divTable"
            style={{
              width: table.getTotalSize(),
            }}
          >
            <div className="thead">
              {table.getHeaderGroups().map((headerGroup) => (
                <div
                  key={headerGroup.id}
                  className="tr"
                  style={{
                    position: 'relative',
                  }}
                >
                  {headerGroup.headers.map((header) => (
                    <div
                      key={header.id}
                      className="th"
                      style={{
                        position: 'absolute',
                        left: header.getStart(),
                        width: header.getSize(),
                      }}
                    >
                      {header.isPlaceholder ? null : (
                        <table.FlexRender header={header} />
                      )}
                      <div
                        onDoubleClick={() => header.column.resetSize()}
                        onMouseDown={header.getResizeHandler()}
                        onTouchStart={header.getResizeHandler()}
                        className={`resizer ${
                          table.options.columnResizeDirection
                        } ${header.column.getIsResizing() ? 'isResizing' : ''}`}
                        style={{
                          transform:
                            columnResizeMode === 'onEnd' &&
                            header.column.getIsResizing()
                              ? `translateX(${
                                  (table.options.columnResizeDirection === 'rtl'
                                    ? -1
                                    : 1) *
                                  (table.state.columnResizing.deltaOffset ?? 0)
                                }px)`
                              : '',
                        }}
                      />
                    </div>
                  ))}
                </div>
              ))}
            </div>
            <div className="tbody">
              {table.getRowModel().rows.map((row) => (
                <div
                  key={row.id}
                  className="tr"
                  style={{
                    position: 'relative',
                  }}
                >
                  {row.getAllCells().map((cell) => (
                    <div
                      key={cell.id}
                      className="td"
                      style={{
                        position: 'absolute',
                        left: cell.column.getStart(),
                        width: cell.column.getSize(),
                      }}
                    >
                      <table.FlexRender cell={cell} />
                    </div>
                  ))}
                </div>
              ))}
            </div>
          </div>
        </div>
      </div>
      <div className="spacer-md" />
      <button onClick={() => rerender()} className="demo-button">
        Rerender
      </button>
      <pre>{JSON.stringify(table.state, null, 2)}</pre>
    </div>
  )
}

const rootElement = document.getElementById('root')
if (!rootElement) throw new Error('Failed to find the root element')

ReactDOM.createRoot(rootElement).render(
  <React.StrictMode>
    <App />
  </React.StrictMode>,
)
import React from 'react'
import ReactDOM from 'react-dom/client'
import {
  columnResizingFeature,
  columnSizingFeature,
  createColumnHelper,
  tableFeatures,
  useTable,
} from '@tanstack/react-table'
import { makeData } from './makeData'
import type {
  ColumnResizeDirection,
  ColumnResizeMode,
} from '@tanstack/react-table'
import type { Person } from './makeData'
import './index.css'

const features = tableFeatures({ columnResizingFeature, columnSizingFeature })

const columnHelper = createColumnHelper<typeof features, Person>()

const columns = columnHelper.columns([
  columnHelper.group({
    header: 'Name',
    footer: (props) => props.column.id,
    columns: columnHelper.columns([
      columnHelper.accessor('firstName', {
        cell: (info) => info.getValue(),
        footer: (props) => props.column.id,
      }),
      columnHelper.accessor((row) => row.lastName, {
        id: 'lastName',
        cell: (info) => info.getValue(),
        header: () => <span>Last Name</span>,
        footer: (props) => props.column.id,
      }),
    ]),
  }),
  columnHelper.group({
    header: 'Info',
    footer: (props) => props.column.id,
    columns: columnHelper.columns([
      columnHelper.accessor('age', {
        header: () => 'Age',
        footer: (props) => props.column.id,
      }),
      columnHelper.group({
        header: 'More Info',
        columns: columnHelper.columns([
          columnHelper.accessor('visits', {
            header: () => <span>Visits</span>,
            footer: (props) => props.column.id,
          }),
          columnHelper.accessor('status', {
            header: 'Status',
            footer: (props) => props.column.id,
          }),
          columnHelper.accessor('progress', {
            header: 'Profile Progress',
            footer: (props) => props.column.id,
          }),
        ]),
      }),
    ]),
  }),
])

function App() {
  const [data, setData] = React.useState(() => makeData(10))
  const refreshData = () => setData(makeData(10))
  const stressTest = () => setData(makeData(100))

  const [columnResizeMode, setColumnResizeMode] =
    React.useState<ColumnResizeMode>('onChange')

  const [columnResizeDirection, setColumnResizeDirection] =
    React.useState<ColumnResizeDirection>('ltr')

  const rerender = React.useReducer(() => ({}), {})[1]

  const table = useTable(
    {
      features,
      rowModels: {},
      columns,
      data,
      columnResizeMode,
      columnResizeDirection,
      debugTable: true,
      debugHeaders: true,
      debugColumns: true,
    },
    (state) => state, // default selector
  )

  return (
    <div className="demo-root">
      <div>
        <button onClick={() => refreshData()} className="demo-button">
          Regenerate Data
        </button>
        <button onClick={() => stressTest()} className="demo-button">
          Stress Test (100 rows)
        </button>
      </div>
      <div className="spacer-md" />
      <select
        value={columnResizeMode}
        onChange={(e) =>
          setColumnResizeMode(e.target.value as ColumnResizeMode)
        }
        className="demo-button outlined-control"
      >
        <option value="onEnd">Resize: "onEnd"</option>
        <option value="onChange">Resize: "onChange"</option>
      </select>
      <select
        value={columnResizeDirection}
        onChange={(e) =>
          setColumnResizeDirection(e.target.value as ColumnResizeDirection)
        }
        className="demo-button outlined-control"
      >
        <option value="ltr">Resize Direction: "ltr"</option>
        <option value="rtl">Resize Direction: "rtl"</option>
      </select>
      <div style={{ direction: table.options.columnResizeDirection }}>
        <div className="spacer-md" />
        <div className="section-title">{'<table/>'}</div>
        <div className="scroll-container">
          <table style={{ width: table.getCenterTotalSize() }}>
            <thead>
              {table.getHeaderGroups().map((headerGroup) => (
                <tr key={headerGroup.id}>
                  {headerGroup.headers.map((header) => (
                    <th
                      key={header.id}
                      colSpan={header.colSpan}
                      style={{
                        width: header.getSize(),
                      }}
                    >
                      {header.isPlaceholder ? null : (
                        <table.FlexRender header={header} />
                      )}
                      <div
                        onDoubleClick={() => header.column.resetSize()}
                        onMouseDown={header.getResizeHandler()}
                        onTouchStart={header.getResizeHandler()}
                        className={`resizer ${
                          table.options.columnResizeDirection
                        } ${header.column.getIsResizing() ? 'isResizing' : ''}`}
                        style={{
                          transform:
                            columnResizeMode === 'onEnd' &&
                            header.column.getIsResizing()
                              ? `translateX(${
                                  (table.options.columnResizeDirection === 'rtl'
                                    ? -1
                                    : 1) *
                                  (table.state.columnResizing.deltaOffset ?? 0)
                                }px)`
                              : '',
                        }}
                      />
                    </th>
                  ))}
                </tr>
              ))}
            </thead>
            <tbody>
              {table.getRowModel().rows.map((row) => (
                <tr key={row.id}>
                  {row.getAllCells().map((cell) => (
                    <td
                      key={cell.id}
                      style={{
                        width: cell.column.getSize(),
                      }}
                    >
                      <table.FlexRender cell={cell} />
                    </td>
                  ))}
                </tr>
              ))}
            </tbody>
          </table>
        </div>
        <div className="spacer-md" />
        <div className="section-title">{'<div/> (relative)'}</div>
        <div className="scroll-container">
          <div className="divTable" style={{ width: table.getTotalSize() }}>
            <div className="thead">
              {table.getHeaderGroups().map((headerGroup) => (
                <div key={headerGroup.id} className="tr">
                  {headerGroup.headers.map((header) => (
                    <div
                      key={header.id}
                      className="th"
                      style={{
                        width: header.getSize(),
                      }}
                    >
                      {header.isPlaceholder ? null : (
                        <table.FlexRender header={header} />
                      )}
                      <div
                        onDoubleClick={() => header.column.resetSize()}
                        onMouseDown={header.getResizeHandler()}
                        onTouchStart={header.getResizeHandler()}
                        className={`resizer ${
                          table.options.columnResizeDirection
                        } ${header.column.getIsResizing() ? 'isResizing' : ''}`}
                        style={{
                          transform:
                            columnResizeMode === 'onEnd' &&
                            header.column.getIsResizing()
                              ? `translateX(${
                                  (table.options.columnResizeDirection === 'rtl'
                                    ? -1
                                    : 1) *
                                  (table.state.columnResizing.deltaOffset ?? 0)
                                }px)`
                              : '',
                        }}
                      />
                    </div>
                  ))}
                </div>
              ))}
            </div>
            <div className="tbody">
              {table.getRowModel().rows.map((row) => (
                <div key={row.id} className="tr">
                  {row.getAllCells().map((cell) => (
                    <div
                      key={cell.id}
                      className="td"
                      style={{
                        width: cell.column.getSize(),
                      }}
                    >
                      <table.FlexRender cell={cell} />
                    </div>
                  ))}
                </div>
              ))}
            </div>
          </div>
        </div>
        <div className="spacer-md" />
        <div className="section-title">{'<div/> (absolute positioning)'}</div>
        <div className="scroll-container">
          <div
            className="divTable"
            style={{
              width: table.getTotalSize(),
            }}
          >
            <div className="thead">
              {table.getHeaderGroups().map((headerGroup) => (
                <div
                  key={headerGroup.id}
                  className="tr"
                  style={{
                    position: 'relative',
                  }}
                >
                  {headerGroup.headers.map((header) => (
                    <div
                      key={header.id}
                      className="th"
                      style={{
                        position: 'absolute',
                        left: header.getStart(),
                        width: header.getSize(),
                      }}
                    >
                      {header.isPlaceholder ? null : (
                        <table.FlexRender header={header} />
                      )}
                      <div
                        onDoubleClick={() => header.column.resetSize()}
                        onMouseDown={header.getResizeHandler()}
                        onTouchStart={header.getResizeHandler()}
                        className={`resizer ${
                          table.options.columnResizeDirection
                        } ${header.column.getIsResizing() ? 'isResizing' : ''}`}
                        style={{
                          transform:
                            columnResizeMode === 'onEnd' &&
                            header.column.getIsResizing()
                              ? `translateX(${
                                  (table.options.columnResizeDirection === 'rtl'
                                    ? -1
                                    : 1) *
                                  (table.state.columnResizing.deltaOffset ?? 0)
                                }px)`
                              : '',
                        }}
                      />
                    </div>
                  ))}
                </div>
              ))}
            </div>
            <div className="tbody">
              {table.getRowModel().rows.map((row) => (
                <div
                  key={row.id}
                  className="tr"
                  style={{
                    position: 'relative',
                  }}
                >
                  {row.getAllCells().map((cell) => (
                    <div
                      key={cell.id}
                      className="td"
                      style={{
                        position: 'absolute',
                        left: cell.column.getStart(),
                        width: cell.column.getSize(),
                      }}
                    >
                      <table.FlexRender cell={cell} />
                    </div>
                  ))}
                </div>
              ))}
            </div>
          </div>
        </div>
      </div>
      <div className="spacer-md" />
      <button onClick={() => rerender()} className="demo-button">
        Rerender
      </button>
      <pre>{JSON.stringify(table.state, null, 2)}</pre>
    </div>
  )
}

const rootElement = document.getElementById('root')
if (!rootElement) throw new Error('Failed to find the root element')

ReactDOM.createRoot(rootElement).render(
  <React.StrictMode>
    <App />
  </React.StrictMode>,
)

Docs
Cloudflare
Railway
CodeRabbit
SerpAPI
AG Grid
OpenRouter
Netlify
WorkOS
Clerk
Unkey
Prisma
Sentry
Electric
Cloudflare
Railway
CodeRabbit
SerpAPI
AG Grid
OpenRouter
Netlify
WorkOS
Clerk
Unkey
Prisma
Sentry
Electric
Table API Reference
Column API Reference
Row API Reference
Cell API Reference
Header API Reference
Features API Reference
Static Functions API Reference

Vue Example: Column Resizing

<script setup lang="ts">
import {
  FlexRender,
  createColumnHelper,
  createPaginatedRowModel,
  rowPaginationFeature,
  tableFeatures,
  useTable,
} from '@tanstack/vue-table'
import { ref } from 'vue'
import { makeData } from './makeData'
import type { Person } from './makeData'

const features = tableFeatures({
  rowPaginationFeature,
})

const columnHelper = createColumnHelper<typeof features, Person>()

const INITIAL_PAGE_INDEX = 0

const goToPageNumber = ref(INITIAL_PAGE_INDEX + 1)
const pageSizes = [10, 20, 30, 40, 50]
const data = ref(makeData(1_000))

const columns = ref(
  columnHelper.columns([
    columnHelper.group({
      header: 'Name',
      footer: (props) => props.column.id,
      columns: columnHelper.columns([
        columnHelper.accessor('firstName', {
          cell: (info) => info.getValue(),
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor((row) => row.lastName, {
          id: 'lastName',
          cell: (info) => info.getValue(),
          header: () => 'Last Name',
          footer: (props) => props.column.id,
        }),
      ]),
    }),
    columnHelper.group({
      header: 'Info',
      footer: (props) => props.column.id,
      columns: columnHelper.columns([
        columnHelper.accessor('age', {
          header: () => 'Age',
          footer: (props) => props.column.id,
        }),
        columnHelper.group({
          header: 'More Info',
          columns: columnHelper.columns([
            columnHelper.accessor('visits', {
              header: () => 'Visits',
              footer: (props) => props.column.id,
            }),
            columnHelper.accessor('status', {
              header: 'Status',
              footer: (props) => props.column.id,
            }),
            columnHelper.accessor('progress', {
              header: 'Profile Progress',
              footer: (props) => props.column.id,
            }),
          ]),
        }),
      ]),
    }),
  ]),
)

const table = useTable({
  features,
  rowModels: {
    paginatedRowModel: createPaginatedRowModel(),
  },
  data,
  get columns() {
    return columns.value
  },
  debugTable: true,
})

const refreshData = () => {
  data.value = makeData(1_000)
}

const stressTest = () => {
  data.value = makeData(200_000)
}

function handleGoToPage(e: any) {
  const page = e.target.value ? Number(e.target.value) - 1 : 0
  goToPageNumber.value = page + 1
  table.setPageIndex(page)
}

function handlePageSizeChange(e: any) {
  table.setPageSize(Number(e.target.value))
}
</script>

<template>
  <div class="demo-root">
    <div class="button-row">
      <button @click="refreshData" class="demo-button">Regenerate Data</button>
      <button @click="stressTest" class="demo-button">
        Stress Test (200k rows)
      </button>
    </div>
    <div class="spacer-md" />
    <table>
      <thead>
        <tr
          v-for="headerGroup in table.getHeaderGroups()"
          :key="headerGroup.id"
        >
          <th
            v-for="header in headerGroup.headers"
            :key="header.id"
            :colSpan="header.colSpan"
          >
            <FlexRender v-if="!header.isPlaceholder" :header="header" />
          </th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="row in table.getRowModel().rows" :key="row.id">
          <td v-for="cell in row.getAllCells()" :key="cell.id">
            <FlexRender :cell="cell" />
          </td>
        </tr>
      </tbody>
      <tfoot>
        <tr
          v-for="footerGroup in table.getFooterGroups()"
          :key="footerGroup.id"
        >
          <th
            v-for="header in footerGroup.headers"
            :key="header.id"
            :colSpan="header.colSpan"
          >
            <FlexRender v-if="!header.isPlaceholder" :footer="header" />
          </th>
        </tr>
      </tfoot>
    </table>
    <div>
      <div class="controls">
        <button
          class="demo-button demo-button-sm"
          @click="() => table.setPageIndex(0)"
          :disabled="!table.getCanPreviousPage()"
        >
          «
        </button>
        <button
          class="demo-button demo-button-sm"
          @click="() => table.previousPage()"
          :disabled="!table.getCanPreviousPage()"
        >

        </button>
        <button
          class="demo-button demo-button-sm"
          @click="() => table.nextPage()"
          :disabled="!table.getCanNextPage()"
        >

        </button>
        <button
          class="demo-button demo-button-sm"
          @click="() => table.setPageIndex(table.getPageCount() - 1)"
          :disabled="!table.getCanNextPage()"
        >
          »
        </button>
        <span class="inline-controls">
          <div>Page</div>
          <strong>
            {{ (table.atoms.pagination.get().pageIndex + 1).toLocaleString() }}
            of
            {{ table.getPageCount().toLocaleString() }}
          </strong>
        </span>
        <span class="inline-controls">
          | Go to page:
          <input
            type="number"
            :value="goToPageNumber"
            @change="handleGoToPage"
            class="page-size-input"
          />
        </span>
        <select
          :value="table.atoms.pagination.get().pageSize"
          @change="handlePageSizeChange"
        >
          <option
            :key="pageSize"
            :value="pageSize"
            v-for="pageSize in pageSizes"
          >
            Show {{ pageSize }}
          </option>
        </select>
      </div>
      <div>{{ table.getRowModel().rows.length.toLocaleString() }} Rows</div>
      <pre>{{ JSON.stringify(table.atoms.pagination.get(), null, 2) }}</pre>
    </div>
    <div class="spacer-sm" />
  </div>
</template>

<style>
html {
  font-family: sans-serif;
  font-size: 14px;
}

table {
  border-spacing: 0;
  border-collapse: collapse;
  border: 1px solid lightgray;
}

tbody {
  border-bottom: 1px solid lightgray;
}

th {
  border-bottom: 1px solid lightgray;
  border-right: 1px solid lightgray;
  padding: 2px 4px;
}

tfoot {
  color: gray;
}

tfoot th {
  font-weight: normal;
}
</style>
<script setup lang="ts">
import {
  FlexRender,
  createColumnHelper,
  createPaginatedRowModel,
  rowPaginationFeature,
  tableFeatures,
  useTable,
} from '@tanstack/vue-table'
import { ref } from 'vue'
import { makeData } from './makeData'
import type { Person } from './makeData'

const features = tableFeatures({
  rowPaginationFeature,
})

const columnHelper = createColumnHelper<typeof features, Person>()

const INITIAL_PAGE_INDEX = 0

const goToPageNumber = ref(INITIAL_PAGE_INDEX + 1)
const pageSizes = [10, 20, 30, 40, 50]
const data = ref(makeData(1_000))

const columns = ref(
  columnHelper.columns([
    columnHelper.group({
      header: 'Name',
      footer: (props) => props.column.id,
      columns: columnHelper.columns([
        columnHelper.accessor('firstName', {
          cell: (info) => info.getValue(),
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor((row) => row.lastName, {
          id: 'lastName',
          cell: (info) => info.getValue(),
          header: () => 'Last Name',
          footer: (props) => props.column.id,
        }),
      ]),
    }),
    columnHelper.group({
      header: 'Info',
      footer: (props) => props.column.id,
      columns: columnHelper.columns([
        columnHelper.accessor('age', {
          header: () => 'Age',
          footer: (props) => props.column.id,
        }),
        columnHelper.group({
          header: 'More Info',
          columns: columnHelper.columns([
            columnHelper.accessor('visits', {
              header: () => 'Visits',
              footer: (props) => props.column.id,
            }),
            columnHelper.accessor('status', {
              header: 'Status',
              footer: (props) => props.column.id,
            }),
            columnHelper.accessor('progress', {
              header: 'Profile Progress',
              footer: (props) => props.column.id,
            }),
          ]),
        }),
      ]),
    }),
  ]),
)

const table = useTable({
  features,
  rowModels: {
    paginatedRowModel: createPaginatedRowModel(),
  },
  data,
  get columns() {
    return columns.value
  },
  debugTable: true,
})

const refreshData = () => {
  data.value = makeData(1_000)
}

const stressTest = () => {
  data.value = makeData(200_000)
}

function handleGoToPage(e: any) {
  const page = e.target.value ? Number(e.target.value) - 1 : 0
  goToPageNumber.value = page + 1
  table.setPageIndex(page)
}

function handlePageSizeChange(e: any) {
  table.setPageSize(Number(e.target.value))
}
</script>

<template>
  <div class="demo-root">
    <div class="button-row">
      <button @click="refreshData" class="demo-button">Regenerate Data</button>
      <button @click="stressTest" class="demo-button">
        Stress Test (200k rows)
      </button>
    </div>
    <div class="spacer-md" />
    <table>
      <thead>
        <tr
          v-for="headerGroup in table.getHeaderGroups()"
          :key="headerGroup.id"
        >
          <th
            v-for="header in headerGroup.headers"
            :key="header.id"
            :colSpan="header.colSpan"
          >
            <FlexRender v-if="!header.isPlaceholder" :header="header" />
          </th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="row in table.getRowModel().rows" :key="row.id">
          <td v-for="cell in row.getAllCells()" :key="cell.id">
            <FlexRender :cell="cell" />
          </td>
        </tr>
      </tbody>
      <tfoot>
        <tr
          v-for="footerGroup in table.getFooterGroups()"
          :key="footerGroup.id"
        >
          <th
            v-for="header in footerGroup.headers"
            :key="header.id"
            :colSpan="header.colSpan"
          >
            <FlexRender v-if="!header.isPlaceholder" :footer="header" />
          </th>
        </tr>
      </tfoot>
    </table>
    <div>
      <div class="controls">
        <button
          class="demo-button demo-button-sm"
          @click="() => table.setPageIndex(0)"
          :disabled="!table.getCanPreviousPage()"
        >
          «
        </button>
        <button
          class="demo-button demo-button-sm"
          @click="() => table.previousPage()"
          :disabled="!table.getCanPreviousPage()"
        >

        </button>
        <button
          class="demo-button demo-button-sm"
          @click="() => table.nextPage()"
          :disabled="!table.getCanNextPage()"
        >

        </button>
        <button
          class="demo-button demo-button-sm"
          @click="() => table.setPageIndex(table.getPageCount() - 1)"
          :disabled="!table.getCanNextPage()"
        >
          »
        </button>
        <span class="inline-controls">
          <div>Page</div>
          <strong>
            {{ (table.atoms.pagination.get().pageIndex + 1).toLocaleString() }}
            of
            {{ table.getPageCount().toLocaleString() }}
          </strong>
        </span>
        <span class="inline-controls">
          | Go to page:
          <input
            type="number"
            :value="goToPageNumber"
            @change="handleGoToPage"
            class="page-size-input"
          />
        </span>
        <select
          :value="table.atoms.pagination.get().pageSize"
          @change="handlePageSizeChange"
        >
          <option
            :key="pageSize"
            :value="pageSize"
            v-for="pageSize in pageSizes"
          >
            Show {{ pageSize }}
          </option>
        </select>
      </div>
      <div>{{ table.getRowModel().rows.length.toLocaleString() }} Rows</div>
      <pre>{{ JSON.stringify(table.atoms.pagination.get(), null, 2) }}</pre>
    </div>
    <div class="spacer-sm" />
  </div>
</template>

<style>
html {
  font-family: sans-serif;
  font-size: 14px;
}

table {
  border-spacing: 0;
  border-collapse: collapse;
  border: 1px solid lightgray;
}

tbody {
  border-bottom: 1px solid lightgray;
}

th {
  border-bottom: 1px solid lightgray;
  border-right: 1px solid lightgray;
  padding: 2px 4px;
}

tfoot {
  color: gray;
}

tfoot th {
  font-weight: normal;
}
</style>